package MT::Plugin::SKR::Binmode;
# Binmode - Enable you to generate binary data set
#       Copyright (c) 2009 SKYARC System Co.,Ltd.
#       http://www.skyarc.co.jp/engineerblog/entry/movabletype_binmode.html

use strict;
use MT::Template::Context;

use vars qw( $MYNAME $VERSION );
$MYNAME = 'Binmode';
$VERSION = '0.01';

use base qw( MT::Plugin );
my $plugin = __PACKAGE__->new({
        name => $MYNAME,
        id => lc $MYNAME,
        key => lc $MYNAME,
        version => $VERSION,
        author_name => 'SKYARC System Co.,Ltd.',
        author_link => 'http://www.skyarc.co.jp/',
        doc_link => 'http://www.skyarc.co.jp/engineerblog/entry/movabletype_binmode.html',
        description => <<HTMLHEREDOC,
<__trans phrase="Enable you to generate binary data set">
HTMLHEREDOC
});
MT->add_plugin( $plugin );

sub instance { $plugin; }



### Global filter - binmode
MT::Template::Context->add_global_filter( 'binmode' => \&_fltr_binmode );
sub _fltr_binmode {
    my ($text, $arg, $ctx) = @_;
    $text =~ s!(\\\\|\\x[0-9a-fA-F]{1,2}|\\0[0-7]{1,3}|\\b[01]{1,8})!sub {
        my ($str) = @_;
        return '\\' if $str eq '\\\\';
        $str =~ s/^\\/0/;
        return chr oct $str;
    }->($1)!gse;
    $text;
}

1;